﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.5
@EndOfDesignText@
#Event: Change(Value As Float)
#DesignerProperty: Key: BackgroundColor, DisplayName: Background Color, FieldType: Color, DefaultValue: 0xFFFFFFFF, Description: Background color

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As B4XView 'ignore
	Private xui As XUI 'ignore
	
	Private Pa,PanelX As B4XView
	Private Can As B4XCanvas
	Private Quad As Float
	Private clr As Int
	Private Valore As Float = 50
	Private Colore As Int
	Private ColoreSole As Int 
	Private ColoreLuna As Int 
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	
	PanelX= xui.CreatePanel("")
	PanelX.SetLayoutAnimated(0,0,0,200dip,200dip)
	Can.Initialize(PanelX)
	
	Colore = xui.Color_Black
	ColoreSole = xui.Color_RGB(255,212,0)
	ColoreLuna = xui.Color_LightGray
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
	mBase.Color=xui.Color_Transparent
	clr = xui.PaintOrColorToColor(Props.Get("BackgroundColor")) 'Example of getting a color value from Props
	
	Quad=Min(mBase.Width,mBase.Height)
	#IF B4A
		Pa=xui.CreatePanel("Pa")
	#ELSE IF B4J or B4i
		Dim Im As ImageView
		Im.Initialize("Pa")
		Pa=Im
	#END IF
	Pa.SetLayoutAnimated(0,0,0,Quad,Quad)
	Pa.Color=clr
	mBase.AddView(Pa,(mBase.Width-Quad)/2,(mBase.Height-Quad)/2,Quad,Quad)
	Invalidate
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	Quad=Min(Width,Height)
	Pa.Left=(Width-Quad)/2
	Pa.Top=(Height-Quad)/2
	Pa.Width=Quad
	Pa.Height=Quad
	Invalidate
End Sub

Public Sub getValue As Float
	Return Valore
End Sub

Public Sub setValue(F As Float)
	Valore=F
	Invalidate
End Sub

Public Sub Invalidate
	Dim Raggio As Int = 45dip
	Dim StartRay As Int = 50dip
	Dim LengthRay As Int = 20dip
	Dim CenterCircle As Int = 85dip
	
	Can.DrawRect(Can.TargetRect,clr,True,1)
	Can.DrawLine(180dip,10dip,180dip,190dip,Colore,1dip)
	Can.Invalidate
	For i=1 To 19 
		Dim H As Float = (i*100dip/10)
		If i=1 Or i= 10 Or i = 19  Then 
			Can.DrawLine(173dip,H,187dip,H,Colore,3dip)
		Else
			Can.DrawLine(176dip,H,184dip,H,Colore,1dip)
		End If
	Next
	If Valore<55 Then
		'alto
		Can.DrawCircle(CenterCircle,100dip,Raggio,ColoreSole,True,1)
		Dim Raggio3 As Int =StartRay + (LengthRay * (80-Valore) / 80)
		For Deg=1 To 360 Step 45
			Dim X As Float=SinD(Deg+Valore)
			Dim Y As Float=CosD(Deg+Valore)
			Can.DrawLine(CenterCircle+X*StartRay,100dip+Y*StartRay,CenterCircle+X*Raggio3,100dip+Y*Raggio3,ColoreSole,6dip)
		Next
	Else
		'basso
		Dim Dst As Float = ((120-Valore)*100dip/100)
		Can.DrawCircle(CenterCircle,100dip,Raggio,Gradiend(ColoreSole,ColoreLuna,Valore),True,1)
		Can.DrawCircle(CenterCircle-Dst,100dip-Dst,Raggio,clr,True,1)
	End If
	Can.Invalidate
	
	Pa.SetBitmap(Can.CreateBitmap.Resize(Quad,Quad,True))
End Sub

Private Sub Gradiend(C1 As Int, C2 As Int, Grad As Int) As Int
	Dim C As Int
	Dim a1,r1,g1,b1 As Int
	Dim a2,r2,g2,b2 As Int
	Dim a3,r3,g3,b3 As Int
	
	a1 = Bit.And(0xff, Bit.ShiftRight(C1, 24))
	r1 = Bit.And(0xff, Bit.ShiftRight(C1, 16))
	g1 =  Bit.And(0xff, Bit.ShiftRight(C1, 8))
	b1 =  Bit.And(0xff, C1)
	
	a2 = Bit.And(0xff, Bit.ShiftRight(C2, 24))
	r2 = Bit.And(0xff, Bit.ShiftRight(C2, 16))
	g2 =  Bit.And(0xff, Bit.ShiftRight(C2, 8))
	b2 =  Bit.And(0xff, C2)
	
	a3=a1+Grad*(a2-a1)/100
	r3=r1+Grad*(r2-r1)/100
	g3=g1+Grad*(g2-g1)/100
	b3=b1+Grad*(b2-b1)/100
	
	C=xui.Color_ARGB(a3,r3,g3,b3)
	Return c
End Sub

#IF B4A

Private Sub Pa_Touch (Action As Int, X As Float, Y As Float)
	If X>Pa.Width/2 Then
		Valore = (Y/Pa.Height)*100
		Valore=Max(Min(Valore,100),0)
		Invalidate
		If xui.SubExists(mCallBack,mEventName & "_Change",1) Then CallSub2(mCallBack,mEventName & "_Change",Valore)
	End If
End Sub

#ELSE IF B4J

Private Sub Pa_MouseDragged (EventData As MouseEvent)
		If EventData.X>Pa.Width/2 Then
			Valore = (EventData.Y/Pa.Height)*100
			Valore=Max(Min(Valore,100),0)
			Invalidate
			If xui.SubExists(mCallBack,mEventName & "_Change",1) then CallSub2(mCallBack,mEventName & "_Change",Valore)
		End If
End Sub

#ELSE IF B4i

Private Sub Base_Touch(Action As Int, X As Float, Y As Float)
	If X>Pa.Width/2 Then
		Valore = (Y/Pa.Height)*100
		Valore=Max(Min(Valore,100),0)
		Invalidate
		If xui.SubExists(mCallBack,mEventName & "_Change",1) then CallSub2(mCallBack,mEventName & "_Change",Valore)
	End If
End Sub

#END IF